diff --git a/web/pgadmin/tools/sqleditor/tests/test_new_connection_database.py b/web/pgadmin/tools/sqleditor/tests/test_new_connection_database.py
new file mode 100644
index 0000000..20fe3e3
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/tests/test_new_connection_database.py
@@ -0,0 +1,98 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import json
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.test_setup import config_data
+from regression.python_test_utils import test_utils as utils
+
+
+class TestNewConnectionDatabase(BaseTestGenerator):
+    """ This class will test new connection database. """
+    scenarios = [
+        ('New connection dialog',
+         dict(
+             url="/sqleditor/new_connection_database/",
+             is_positive_test=True,
+             mocking_required=False,
+             is_server_conn_required=False,
+             test_data={},
+             mock_data={},
+             expected_data={
+                 "status_code": 200
+             }
+         )),
+        ('New connection dialog connect server',
+         dict(
+             url="/sqleditor/new_connection_database/",
+             is_positive_test=True,
+             mocking_required=False,
+             is_server_conn_required=True,
+             test_data={},
+             mock_data={},
+             expected_data={
+                 "status_code": 200
+             }
+         )),
+        ('New connection dialog negative',
+         dict(
+             url="/sqleditor/new_connection_database/",
+             is_positive_test=False,
+             mocking_required=False,
+             is_server_conn_required=True,
+             test_data={},
+             mock_data={},
+             expected_data={
+                 "status_code": 200
+             }
+         )),
+    ]
+
+    def setUp(self):
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.sgid = config_data['server_group']
+
+    def get_database(self):
+        response = self.tester.get(
+            self.url + str(self.sgid) + '/' + str(self.sid),
+            content_type='html/json'
+        )
+
+        return response
+
+    def runTest(self):
+        if self.is_positive_test:
+            if self.is_server_conn_required:
+                self.server['password'] = self.server['db_password']
+                server_response = self.tester.post(
+                    '/browser/server/connect/{0}/{1}'.format(
+                        utils.SERVER_GROUP,
+                        self.sid),
+                    data=json.dumps(self.server),
+                    content_type='html/json'
+                )
+            response = self.get_database()
+            actual_response_code = response.status_code
+            expected_response_code = self.expected_data['status_code']
+        else:
+            if self.is_server_conn_required:
+                self.server['password'] = self.server['db_password']
+                server_response = self.tester.post(
+                    '/browser/server/connect/{0}/{1}'.format(
+                        utils.SERVER_GROUP,
+                        self.sid),
+                    data=json.dumps(self.server),
+                    content_type='html/json'
+                )
+            self.sid = 0
+            response = self.get_database()
+            actual_response_code = response.status_code
+            expected_response_code = self.expected_data['status_code']
+        self.assertEqual(actual_response_code, expected_response_code)
diff --git a/web/pgadmin/tools/sqleditor/tests/test_new_connection_dialog.py b/web/pgadmin/tools/sqleditor/tests/test_new_connection_dialog.py
new file mode 100644
index 0000000..75a47ef
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/tests/test_new_connection_dialog.py
@@ -0,0 +1,50 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+import json
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.test_setup import config_data
+from regression.python_test_utils import test_utils as utils
+
+
+class TestNewConnectionDialog(BaseTestGenerator):
+    """ This class will test new connection dialog. """
+    scenarios = [
+        ('New connection dialog',
+         dict(
+             url="/sqleditor/new_connection_dialog/",
+             is_positive_test=True,
+             mocking_required=False,
+             is_connect_server=False,
+             test_data={},
+             mock_data={},
+             expected_data={
+                 "status_code": 200
+             }
+         )),
+    ]
+
+    def setUp(self):
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.sgid = config_data['server_group']
+
+    def new_connection(self):
+        response = self.tester.get(
+            self.url + str(self.sgid) + '/' + str(self.sgid),
+            content_type='html/json'
+        )
+
+        return response
+
+    def runTest(self):
+        if self.is_positive_test:
+            response = self.new_connection()
+            actual_response_code = response.status_code
+            expected_response_code = self.expected_data['status_code']
+            self.assertEqual(actual_response_code, expected_response_code)
diff --git a/web/pgadmin/tools/sqleditor/tests/test_new_connection_user.py b/web/pgadmin/tools/sqleditor/tests/test_new_connection_user.py
new file mode 100644
index 0000000..7b6c12e
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/tests/test_new_connection_user.py
@@ -0,0 +1,98 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import json
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from regression.test_setup import config_data
+from regression.python_test_utils import test_utils as utils
+
+
+class TestNewConnectionUser(BaseTestGenerator):
+    """ This class will test new connection user. """
+    scenarios = [
+        ('New connection dialog',
+         dict(
+             url="/sqleditor/new_connection_user/",
+             is_positive_test=True,
+             mocking_required=False,
+             is_server_conn_required=False,
+             test_data={},
+             mock_data={},
+             expected_data={
+                 "status_code": 200
+             }
+         )),
+        ('New connection dialog connect server',
+         dict(
+             url="/sqleditor/new_connection_user/",
+             is_positive_test=True,
+             mocking_required=False,
+             is_server_conn_required=True,
+             test_data={},
+             mock_data={},
+             expected_data={
+                 "status_code": 200
+             }
+         )),
+        ('New connection dialog negative',
+         dict(
+             url="/sqleditor/new_connection_user/",
+             is_positive_test=False,
+             mocking_required=False,
+             is_server_conn_required=True,
+             test_data={},
+             mock_data={},
+             expected_data={
+                 "status_code": 200
+             }
+         )),
+    ]
+
+    def setUp(self):
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.sgid = config_data['server_group']
+
+    def get_use(self):
+        response = self.tester.get(
+            self.url + str(self.sgid) + '/' + str(self.sid),
+            content_type='html/json'
+        )
+
+        return response
+
+    def runTest(self):
+        if self.is_positive_test:
+            if self.is_server_conn_required:
+                self.server['password'] = self.server['db_password']
+                server_response = self.tester.post(
+                    '/browser/server/connect/{0}/{1}'.format(
+                        utils.SERVER_GROUP,
+                        self.sid),
+                    data=json.dumps(self.server),
+                    content_type='html/json'
+                )
+            response = self.get_use()
+            actual_response_code = response.status_code
+            expected_response_code = self.expected_data['status_code']
+        else:
+            if self.is_server_conn_required:
+                self.server['password'] = self.server['db_password']
+                server_response = self.tester.post(
+                    '/browser/server/connect/{0}/{1}'.format(
+                        utils.SERVER_GROUP,
+                        self.sid),
+                    data=json.dumps(self.server),
+                    content_type='html/json'
+                )
+            self.sid = 0
+            response = self.get_use()
+            actual_response_code = response.status_code
+            expected_response_code = self.expected_data['status_code']
+        self.assertEqual(actual_response_code, expected_response_code)
diff --git a/web/pgadmin/utils/driver/psycopg2/connection.py b/web/pgadmin/utils/driver/psycopg2/connection.py
index 9cb65bc..83c2c17 100644
--- a/web/pgadmin/utils/driver/psycopg2/connection.py
+++ b/web/pgadmin/utils/driver/psycopg2/connection.py
@@ -21,7 +21,7 @@ import psycopg2
 from flask import g, current_app
 from flask_babelex import gettext
 from flask_security import current_user
-from pgadmin.utils.crypto import decrypt
+from pgadmin.utils.crypto import decrypt, encrypt
 from psycopg2.extensions import encodings
 
 import config
@@ -211,8 +211,17 @@ class Connection(BaseConnection):
         password = None
         passfile = None
         manager = self.manager
+        encpass = None
+        is_update_password = True
+        crypt_key_present, crypt_key = get_crypt_key()
+
+        if 'user' in kwargs and kwargs['password']:
+            password = kwargs['password']
+            kwargs.pop('password')
+            is_update_password = False
+        else:
+            encpass = kwargs['password'] if 'password' in kwargs else None
 
-        encpass = kwargs['password'] if 'password' in kwargs else None
         passfile = kwargs['passfile'] if 'passfile' in kwargs else None
         tunnel_password = kwargs['tunnel_password'] if 'tunnel_password' in \
                                                        kwargs else ''
@@ -227,16 +236,16 @@ class Connection(BaseConnection):
         if manager.use_ssh_tunnel == 1:
             manager.check_ssh_tunnel_alive()
 
-        if encpass is None:
-            encpass = self.password or getattr(manager, 'password', None)
+        if is_update_password:
+            if encpass is None:
+                encpass = self.password or getattr(manager, 'password', None)
 
-        self.password = encpass
+            self.password = encpass
 
         # Reset the existing connection password
         if self.reconnecting is not False:
             self.password = None
 
-        crypt_key_present, crypt_key = get_crypt_key()
         if not crypt_key_present:
             raise CryptKeyMissing()
 
@@ -269,7 +278,10 @@ class Connection(BaseConnection):
 
         try:
             database = self.db
-            user = manager.user
+            if 'user' in kwargs and kwargs['user']:
+                user = kwargs['user']
+            else:
+                user = manager.user
             conn_id = self.conn_id
 
             import os
@@ -338,10 +350,10 @@ class Connection(BaseConnection):
                 self.wasConnected = False
             raise e
 
-        if status:
+        if status and is_update_password:
             manager._update_password(encpass)
         else:
-            if not self.reconnecting:
+            if not self.reconnecting and is_update_password:
                 self.wasConnected = False
 
         return status, msg
@@ -359,7 +371,7 @@ class Connection(BaseConnection):
             else:
                 self.conn.autocommit = True
 
-    def _set_role(self, manager, cur, conn_id):
+    def _set_role(self, manager, cur, conn_id, **kwargs):
         """
         Set role
         :param manager:
@@ -367,8 +379,18 @@ class Connection(BaseConnection):
         :param conn_id:
         :return:
         """
-        if manager.role:
-            status = self._execute(cur, "SET ROLE TO %s", [manager.role])
+        is_set_role = False
+        role = None
+
+        if 'role' in kwargs and kwargs['role']:
+            is_set_role = True
+            role = kwargs['role']
+        elif manager.role:
+            is_set_role = True
+            role = manager.role
+
+        if is_set_role:
+            status = self._execute(cur, "SET ROLE TO %s", [role])
 
             if status is not None:
                 self.conn.close()
@@ -382,7 +404,7 @@ class Connection(BaseConnection):
                         msg=status
                     )
                 )
-                return False, \
+                return True, \
                     _(
                         "Failed to setup the role with error message:\n{0}"
                     ).format(status)
@@ -445,7 +467,7 @@ class Connection(BaseConnection):
 
             return False, status
 
-        is_error, errmsg = self._set_role(manager, cur, conn_id)
+        is_error, errmsg = self._set_role(manager, cur, conn_id, **kwargs)
         if is_error:
             return False, errmsg
 
@@ -491,7 +513,7 @@ WHERE db.datname = current_database()""")
                 if len(manager.db_info) == 1:
                     manager.did = res['did']
 
-        self._set_user_info(cur, manager)
+        self._set_user_info(cur, manager, **kwargs)
 
         self._set_server_type_and_password(kwargs, manager)
 
@@ -499,7 +521,7 @@ WHERE db.datname = current_database()""")
 
         return True, None
 
-    def _set_user_info(self, cur, manager):
+    def _set_user_info(self, cur, manager, **kwargs):
         """
         Set user info.
         :param cur:
@@ -517,7 +539,7 @@ WHERE db.datname = current_database()""")
         WHERE
             rolname = current_user""")
 
-        if status is None:
+        if status is None and 'user' not in kwargs:
             manager.user_info = dict()
             if cur.rowcount > 0:
                 manager.user_info = cur.fetchmany(1)[0]
